/***************************************************************************
 *   Copyright (C) 2008 by Gernot Pansy                                    *
 *   gernot@pansy.at                                                       *
 *                                                                         *
 *   Note:                                                                 *
 *    This code started off from a mix of StockWidget by Gerhard Gappmeier *
 *    and Stockoid by Jaagup Rep�n.                                        *
 *    So parts of this are also:                                           *
 *    Copyright (c) 2008 Gerhard Gappmeier & Jaagup Rep�n                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef STOCKS_HEADER
#define STOCKS_HEADER

// We need the Plasma Applet headers
#include "ui_stocksConfig.h"
#include <KIcon>
#include <QStringList>

#include <Plasma/Applet>
#include <Plasma/Svg>
#include <Plasma/DataEngine>

struct Stock {
	int index;
	QString sName;
	QString sId;
	float fltValue;
	float fltChange;
	float fltPercentChange;
};

// Define our plasma Applet
class Stocks : public Plasma::Applet {
    Q_OBJECT
    public:
        // Basic Create/Destroy
        Stocks(QObject *parent, const QVariantList &args);
        ~Stocks();

        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                            const QStyleOptionGraphicsItem *option,
                            const QRect& contentsRect);
        void init();

    public slots:
        void addStocks(const QStringList &stockList);
        void removeStocks(const QStringList &stockList);
        void dataUpdated(const QString &source, Plasma::DataEngine::Data data);
        void sltNewSource(const QString &source);
        void sltSourceRemoved(const QString &source);
		
    protected slots:
	void configAccepted();

    protected:
	void createConfigurationInterface(KConfigDialog *parent);
        
    private:
        virtual void drawStock(QPainter *p, Stock *pStock, const QRectF& stockRect);

    private:
        Plasma::DataEngine *m_pStocksEngine;
        QHash<QString, Stock*> m_hashStocks;
	Ui::stocksConfig m_ui;
	QStringList stockList;
	int m_polling_interval;
};

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(stocks, Stocks)

#endif
